Type.registerNamespace('AjaxSet');

AjaxSet.TextEditList = function(element) { 
    AjaxSet.TextEditList.initializeBase(this, [element]);
    this._items = null;
    this._layout = null;
    this._deleteConfirm = null;
    this._isLinkButton = null;
    this._deleteButtonText = null;
    this._addButtonText = null;
    this._fieldCssClass = null;
    this._buttonCssClass = null;
    this._rowCssClass = null;
    this._newItemRowCssClass = null;
    this._maxLength = null;
}

AjaxSet.TextEditList.prototype = {
  initialize : function() {
    AjaxSet.TextEditList.callBaseMethod(this, 'initialize');
    this._onItemClickHandler = Function.createDelegate(this, this._onItemClick);
    control = this.get_element();
    $addHandler(control, "click", this._onItemClickHandler); 
  },

  dispose : function() {
//		$clearHandlers(this);  
    AjaxSet.TextEditList.callBaseMethod(this, 'dispose');
  },

  _onItemClick : function(eventElement) {
		Sys.Debug.trace("eventElement.target.id=" + eventElement.target.id);
		if (eventElement.target.id.indexOf("delbtn") < 0 && eventElement.target.id.indexOf("addbtn") < 0)
			return false;
		control = this.get_element();
		if (eventElement.target.id.indexOf("addbtn") >= 0) {
			if (this._layout == "Table")
				this._addNewItemToTable();
			else
				this._addNewItemToFlow();
		} else {
  		if (this._deleteConfirm)
				if (!window.confirm(this._deleteConfirm))
					return false;
			if (this._layout == "Table")
				this._removeItemFromTable(eventElement.target);
			else
				this._removeItemFromFlow(eventElement.target);
		}
		return false;
  },
  
  _removeItemFromTable : function(sender) {
		tbody = this.get_element().childNodes[0];
		senderRow = sender.parentNode.parentNode;
		senderRow.removeNode(true);
  },
  
  _removeItemFromFlow : function(sender) {
		br = sender.nextSibling;
		field = sender.previousSibling;
		br.removeNode(true);
		field.removeNode(true);
		sender.removeNode(true);
  },
  
  _addNewItemToTable : function() {
		tbody = this.get_element().childNodes[0];
		var lastNumber = -1;
		if (tbody.rows.length >= 2) {
			lastRow = tbody.rows[tbody.rows.length - 2];
			lastRowField = lastRow.cells[0].childNodes[0];
			lastNumber = Number(lastRowField.id.substring(lastRowField.id.lastIndexOf("_") + 1, lastRowField.id.length));
		}
		Sys.Debug.trace("lastNumber=" + lastNumber);
		newRow = tbody.rows[tbody.rows.length - 1].cloneNode(true);
		newRow.className = this._rowCssClass;
		tbody.insertBefore(newRow, tbody.rows[tbody.rows.length - 1]);
		field = newRow.cells[0].childNodes[0];
		button = newRow.cells[1].childNodes[0];
		re = /_/gi;
		name = this.get_element().id.replace(re, "$");
		field.id = this.get_element().id + "_" + (lastNumber + 1);
		field.name = name + "$" + (lastNumber + 1);
		button.id = this.get_element().id + "_delbtn_" + (lastNumber + 1);
		button.name = name + "$delbtn$" + (lastNumber + 1);
		field.value = tbody.rows[tbody.rows.length - 1].cells[0].childNodes[0].value;
		if (this._isLinkButton)
			button.innerText = this._deleteButtonText;
		else
			button.value = this._deleteButtonText;
		tbody.rows[tbody.rows.length - 1].cells[0].childNodes[0].value = "";
		Sys.Debug.traceDump(field, "field");
		Sys.Debug.traceDump(button, "button");
  },
  
  _addNewItemToFlow : function() {
		span = this.get_element();
		var lastNumber = -1;
		if (span.childNodes.length >= 5) {
			lastRowField = span.childNodes[span.childNodes.length - 5];
			lastNumber = Number(lastRowField.id.substring(lastRowField.id.lastIndexOf("_") + 1, lastRowField.id.length));
		}
		field = span.childNodes[span.childNodes.length - 2].cloneNode(true);
		button = span.childNodes[span.childNodes.length - 1].cloneNode(true);
		field.id = this.get_element().id + "_" + (lastNumber + 1);
		field.name = this.get_element().id + "$" + (lastNumber + 1);
		button.id = this.get_element().id + "_delbtn_" + (lastNumber + 1);
		button.name = this.get_element().id + "$delbtn$" + (lastNumber + 1);
		field.value = span.childNodes[span.childNodes.length - 2].value;
		if (this._isLinkButton)
			button.innerText = this._deleteButtonText;
		else
			button.value = this._deleteButtonText;		
		br = document.createElement("BR");
		span.insertBefore(field, span.childNodes[span.childNodes.length - 2]);
		span.insertBefore(button, span.childNodes[span.childNodes.length - 2]);
		span.insertBefore(br, span.childNodes[span.childNodes.length - 2]);
		Sys.Debug.traceDump(field, "field");
		Sys.Debug.traceDump(button, "button");
  },
  
  get_items : function() {
    return this._items;
  },
  set_items : function(value) {
    this._items = value;
  },
  
  get_layout : function() {
    return this._layout;
  },
  set_layout : function(value) {
    this._layout = value;
  },
  
  get_deleteConfirm : function() {
    return this._deleteConfirm;
  },
  set_deleteConfirm : function(value) {
    this._deleteConfirm = value;
  },
  
  get_isLinkButton : function() {
    return this._isLinkButton;
  },
  set_isLinkButton : function(value) {
    this._isLinkButton = value;
  },
  
  get_deleteButtonText : function() {
    return this._deleteButtonText;
  },
  set_deleteButtonText : function(value) {
    this._deleteButtonText = value;
  },
  
  get_addButtonText: function() {
    return this._addButtonText;
  },
  set_addButtonText : function(value) {
    this._addButtonText = value;
  },
 
  get_fieldCssClass : function() {
    return this._fieldCssClass;
  },
  set_fieldCssClass : function(value) {
    this._fieldCssClass = value;
  },
  
  get_buttonCssClass : function() {
    return this._buttonCssClass;
  },
  set_buttonCssClass : function(value) {
    this._buttonCssClass = value;
  },
  
  get_rowCssClass : function() {
    return this._rowCssClass;
  },
  set_rowCssClass : function(value) {
    this._rowCssClass = value;
  },
  
  get_newItemRowCssClass : function() {
    return this._newItemRowCssClass;
  },
  set_newItemRowCssClass: function(value) {
    this._newItemRowCssClass = value;
  },
  
  get_maxLength : function() {
    return this._maxLength;
  },
  set_maxLength : function(value) {
    this._maxLength = value;
  }
}
// Optional descriptor for JSON serialization.
AjaxSet.TextEditList.descriptor = {
    properties: [ {items: 'items', type: Array} ]
}

AjaxSet.TextEditList.registerClass('AjaxSet.TextEditList', Sys.UI.Control);
if (typeof(Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();